﻿using LINQ;

/*
List<Osoba> listaOsób = new List<Osoba>
{
    new Osoba { Id = 1, Imię = "Jacek", Nazwisko = "Matulewski", NumerTelefonu = 566113310, Wiek = 49  },
    new Osoba { Id = 2, Imię = "Jan", Nazwisko = "Kowalski", NumerTelefonu = 376328734, Wiek = 13  },
    new Osoba { Id = 3, Imię = "Janina", Nazwisko = "Kowalski", NumerTelefonu = 384734638, Wiek = 15  },
    new Osoba { Id = 4, Imię = "Jan2", Nazwisko = "Kowalski", NumerTelefonu = 938893475, Wiek = 43  },
    new Osoba { Id = 5, Imię = "Anna", Nazwisko = "Kowalski", NumerTelefonu = 483757834, Wiek = 65  },
    new Osoba { Id = 6, Imię = "Jan", Nazwisko = "Nowak", NumerTelefonu = 376328734, Wiek = 13  },
    new Osoba { Id = 7, Imię = "Jan1", Nazwisko = "Nowak", NumerTelefonu = 384734638, Wiek = 15  },
    new Osoba { Id = 8, Imię = "Magda", Nazwisko = "Nowak", NumerTelefonu = 938893475, Wiek = 43  },
    new Osoba { Id = 9, Imię = "Jan3", Nazwisko = "Nowak", NumerTelefonu = 483757834, Wiek = 65  }
};
*/

List<Osoba> listaOsób = new List<Osoba>
{
    new Osoba { Id = 1, Imię = "Jacek", Nazwisko = "Matulewski", NumerTelefonu = 566113310, Wiek = 49  },
    new Osoba { Id = 2, Imię = "Jan", Nazwisko = "Kowalski", NumerTelefonu = 376328734, Wiek = 49  },
    new Osoba { Id = 3, Imię = "Janina", Nazwisko = "Kowalski", NumerTelefonu = 384734638, Wiek = 49  },
    new Osoba { Id = 4, Imię = "Jan2", Nazwisko = "Kowalski", NumerTelefonu = 938893475, Wiek = 1000  },
    new Osoba { Id = 5, Imię = "Anna", Nazwisko = "Kowalski", NumerTelefonu = 483757834, Wiek = 49  },
    new Osoba { Id = 6, Imię = "Jan", Nazwisko = "Nowak", NumerTelefonu = 376328734, Wiek = 200  },
    new Osoba { Id = 7, Imię = "Jan1", Nazwisko = "Nowak", NumerTelefonu = 384734638, Wiek = 49  },
    new Osoba { Id = 8, Imię = "Magda", Nazwisko = "Nowak", NumerTelefonu = 938893475, Wiek = 49  },
    new Osoba { Id = 9, Imię = "Jan3", Nazwisko = "Nowak", NumerTelefonu = 483757834, Wiek = 49  }
};

string pokażOsoby(IEnumerable<Osoba> listaOsób)
{
    string s = "Lista osób:\n";
    foreach (Osoba osoba in listaOsób)
        s += osoba.ToString() + Environment.NewLine;
    return s;
}

string s = pokażOsoby(listaOsób);
Console.WriteLine(s);

var listaOsóbPełnoletnich = from osoba in listaOsób
                            where osoba.Wiek >= 18
                            orderby osoba.Wiek
                            select osoba;

s = pokażOsoby(listaOsóbPełnoletnich.ToList());
Console.WriteLine(s);

/*
listaOsóbPełnoletnich.ElementAt(0).Wiek = 100;

Console.WriteLine("******");

s = pokażOsoby(listaOsóbPełnoletnich.ToList());
Console.WriteLine(s);

s = pokażOsoby(listaOsób.ToList());
Console.WriteLine(s);


var listaOsóbPełnoletnich1 = listaOsób.Where(o => o.Wiek >= 18).OrderBy(o => o.Wiek).Select(o => o.ToString());

//s = pokażOsoby(listaOsóbPełnoletnich1.ToList());
s = "Lista osób:\n";
foreach (string osoba in listaOsóbPełnoletnich1)
    s += osoba + "\n";
Console.WriteLine(s);

var listaOsóbPełnoletnich2 = from osoba in listaOsób
                             where osoba.Wiek >= 18
                             orderby osoba.Wiek
                             select new { Id = osoba.Id, Imię = osoba.Imię, Nazwisko = osoba.Nazwisko, NumerTelefonu = osoba.NumerTelefonu, Wiek = osoba.Wiek };


return;

s = pokażOsoby(listaOsóbPełnoletnich2.ToList());
Console.WriteLine(s);

Console.WriteLine("#####");

listaOsóbPełnoletnich2 = listaOsóbPełnoletnich2.ToList();
listaOsóbPełnoletnich2.ElementAt(0).Wiek = 101;

s = pokażOsoby(listaOsóbPełnoletnich2.ToList());
Console.WriteLine(s);


s = pokażOsoby(listaOsób.ToList());
Console.WriteLine(s);
*/

/*
Console.WriteLine(listaOsóbPełnoletnich.Max(o => o.Wiek));

Console.WriteLine(listaOsóbPełnoletnich.First(o => o.Wiek > 60));

Console.WriteLine(listaOsóbPełnoletnich.Single(o => o.Wiek == listaOsóbPełnoletnich.Max(o => o.Wiek)));

Console.WriteLine(listaOsóbPełnoletnich.All(o => o.Wiek >= 18));
Console.WriteLine(listaOsóbPełnoletnich.Any(o => o.Wiek >= 100));
*/

var grupyOsóbOTymSamymNazwisku = from osoba in listaOsób
                                 group osoba by osoba.Nazwisko into grupa
                                 select grupa;

Console.WriteLine("Grupy:");
foreach(var grupa in grupyOsóbOTymSamymNazwisku)
{
    Console.WriteLine("Nazwisko: " + grupa.Key);
    foreach (Osoba osoba in grupa) Console.WriteLine(osoba);
    Console.WriteLine();
}

var listaKobiet = from osoba in listaOsób
                  where osoba.Imię.EndsWith("a")
                  select osoba;

s = pokażOsoby(listaKobiet);
Console.WriteLine(s);

//var listaPełnoletnichIKobiet = listaOsóbPełnoletnich.Concat(listaKobiet).Distinct();
var listaPełnoletnichIKobiet = listaOsóbPełnoletnich.Union(listaKobiet);
s = pokażOsoby(listaPełnoletnichIKobiet);
Console.WriteLine(s);

var listaPełnoletnichKobiet = listaOsóbPełnoletnich.Intersect(listaKobiet);
s = pokażOsoby(listaPełnoletnichKobiet);
Console.WriteLine(s);

var listaPełnoletnichNiekobiet = listaOsóbPełnoletnich.Except(listaKobiet);
s = pokażOsoby(listaPełnoletnichNiekobiet);
Console.WriteLine(s);



var listaTelefonów = from osoba in listaOsób
                     select new { osoba.Id, osoba.NumerTelefonu };
var listaPersonaliów = from osoba in listaOsób
                       select new { osoba.Id, osoba.Imię, osoba.Nazwisko };

var lista = from telefon in listaTelefonów
            join personalia in listaPersonaliów
            on telefon.Id equals personalia.Id
            select new { telefon.Id, personalia.Imię, personalia.Nazwisko, telefon.NumerTelefonu };


double[] d = { 45, 34, 23, 34, 100 };
Console.WriteLine(d.StdDev());

Console.WriteLine("$$$$$$");
Console.WriteLine(listaOsób.StdDev(o => o.Wiek));

var filtrowana = listaOsób.OdrzućBłędyGrube(o => o.Wiek);
Console.WriteLine(filtrowana.Count());


